FROM ubuntu:16.04
RUN apt update && apt install
RUN apt -y install git cmake wget make vim python psmisc build-essential
RUN apt -y install m4 libgmp3-dev libmpfr-dev libmpfr-doc libmpfr4 libmpfr4-dbg
RUN apt -y install software-properties-common lsb-release libssl-dev apt-transport-https libssl-dev python-numpy
RUN add-apt-repository ppa:ubuntu-toolchain-r/test
RUN apt update
RUN apt -y install gcc-6 g++-6
RUN update-alternatives --install /usr/bin/gcc gcc /usr/bin/gcc-6 60 --slave /usr/bin/g++ g++ /usr/bin/g++-6

RUN export CC=/usr/bin/gcc-6
RUN export CXX=/usr/bin/g++-6

COPY SPIR.tar.gz /pir/
WORKDIR /pir/
RUN tar -xf SPIR.tar.gz

#Setup cmake 3.23.1
RUN apt remove -y --purge --auto-remove cmake
RUN tar -xf cmake-3.23.1.tar.gz
RUN cd cmake-3.23.1 && ./bootstrap && make && make install 


RUN git clone https://github.com/microsoft/SEAL.git
RUN cd SEAL && git checkout 3.2.0 && cd native/src && cmake . -DSEAL_USE_CXX17=OFF && make && make install
RUN git clone https://git-crysp.uwaterloo.ca/piros/SealPIR.git
RUN cd SealPIR && git checkout piros && cmake . && make
